package sk.kasv.guiworld;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;


public class API {
    private static final String API_KEY = "95e3633703cbf667037379c26f435621";

    public double getTemperature(String cityName) {
        try {
            URL url = new URL("http://api.openweathermap.org/data/2.5/weather?q=" + cityName + "&appid=" + API_KEY);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestMethod("GET");
            conn.setConnectTimeout(5000);
            conn.setReadTimeout(5000);

            int status = conn.getResponseCode();
            if (status == 200) {
                try (BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream()))) {
                    StringBuilder content = new StringBuilder();
                    String inputLine;
                    while ((inputLine = in.readLine()) != null) {
                        content.append(inputLine);
                    }

                    String jsonResponse = content.toString();
                    return extractTemperature(jsonResponse);
                }
            } else {
                System.out.println("Error: Unable to retrieve temperature. Status code: " + status);
            }
            conn.disconnect();
        } catch (IOException e) {
            System.err.println("Error: Failed to fetch temperature: " + e.getMessage());
        }
        return Double.NaN;
    }

    private double extractTemperature(String jsonResponse) {
        try {
            JSONObject jsonObject = new JSONObject(jsonResponse);
            JSONObject mainObject = jsonObject.getJSONObject("main");
            return mainObject.getDouble("temp");
        } catch (JSONException e) {
            System.err.println("Error in parsing the temperature: " + e.getMessage());
            return Double.NaN;
        }
    }
}